#![allow(deprecated)]
use std::fmt;
use std::str;
/// Cardinal axis used for gradient coloring.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum SpatialColorAxis {
    #[serde(rename = "X")]
    X,
    #[serde(rename = "Y")]
    Y,
    #[serde(rename = "Z")]
    Z,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl SpatialColorAxis {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            SpatialColorAxis::X => "X",
            SpatialColorAxis::Y => "Y",
            SpatialColorAxis::Z => "Z",
            SpatialColorAxis::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for SpatialColorAxis {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for SpatialColorAxis {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for SpatialColorAxis {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<SpatialColorAxis, conjure_object::plain::ParseEnumError> {
        match v {
            "X" => Ok(SpatialColorAxis::X),
            "Y" => Ok(SpatialColorAxis::Y),
            "Z" => Ok(SpatialColorAxis::Z),
            v => v.parse().map(|v| SpatialColorAxis::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for SpatialColorAxis {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<SpatialColorAxis, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the SpatialColorAxis enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
